package ru.mai.dep806.collections;

/**
 * Created by EUGENEL on 05.03.2015.
 */
public class MyNameComparator implements java.util.Comparator<MapSample.Person> {

    public enum SortPolicy {SORT_BY_FIRSTNAME, SORT_BY_LAST_NAME}

    private SortPolicy sortPolicy;

    public MyNameComparator(SortPolicy sortPolicy) {
        this.sortPolicy = sortPolicy;
    }

    @Override
    public int compare(MapSample.Person o1, MapSample.Person o2) {
        if (o1 == o2 || o1.equals(o2)) {
            return 0;
        }
        String fullName = sortPolicy == SortPolicy.SORT_BY_LAST_NAME ? o1.lastName : o1.firstName;
        String otherFullName = sortPolicy == SortPolicy.SORT_BY_LAST_NAME ? o2.lastName : o2.firstName;
        return fullName.toLowerCase().compareTo(otherFullName.toLowerCase());
    }
}
