package ru.mai.dep806.iosamples;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.annotations.XStreamAlias;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Serializable;

/**
 * Created by EUGENEL on 03.04.14.
 */
public class XStreamSample {

//    @XStreamAlias("apple")
    public static class Apple {

        private String name;
        private int color;


        public Apple(String name, int color) {
            this.name = name;
            this.color = color;
            System.out.println("Constructor");
        }

        @Override
        public String toString() {
            return super.toString() + " / Apple{" +
                    "name='" + name + '\'' +
                    ", color=" + color +
                    '}';
        }
    }

    public static void main(String[] args) throws IOException {

        XStream xStream = new XStream();
        xStream.autodetectAnnotations(true);
        xStream.alias("apple", Apple.class);
        xStream.toXML(new Apple("Антоновка", 30), new FileWriter("c:/temp/apple.xml"));

        Apple apple = (Apple) xStream.fromXML(new FileReader("c:/temp/apple.xml"));
        System.out.println(apple);
    }
}
