package ru.mai.dep806.web;

import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Random;

/**
 * Created with IntelliJ IDEA.
 * User: EUGENEL
 * Date: 11.11.13
 * Time: 11:19
 * To change this template use File | Settings | File Templates.
 */
public class CaptchaServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        // 1. Сгенерировать случайное числа от 1000 до 9999

        int num = new Random(System.currentTimeMillis()).nextInt(9999 - 1000) + 1000;

        // 2. Сгенерировать картинку с числом

        BufferedImage image = new BufferedImage(50, 20, BufferedImage.TYPE_INT_RGB);
        Graphics2D graphics = (Graphics2D) image.getGraphics();
        graphics.setColor(Color.GREEN);
        graphics.fillRect(0, 0, 50, 20);
        graphics.setColor(Color.BLACK);
        graphics.drawString(String.valueOf(num), 0, 18);

        // 3. Вывести картинку в response
        resp.setContentType("image/png");
        OutputStream out = resp.getOutputStream();
        ImageIO.write(image, "png", out);

        // 4. Запомнить число

        req.getSession().setAttribute("lastNumber", num);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String userCaptcha = req.getParameter("captchaText");
        int lastNumber = (Integer) req.getSession().getAttribute("lastNumber");
        req.getSession().removeAttribute("lastNumber");
        if (!String.valueOf(lastNumber).equals(userCaptcha)) {
            resp.setStatus(401);
        } else {
            resp.sendRedirect(req.getContextPath() + resp.encodeRedirectURL("/"));
        }
    }
}
