package ru.mai.dep806.threads;

import java.io.File;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * Created by EUGENEL on 23.04.2015.
 */
public class FileSystemSample {



    public static void main(String[] args) throws InterruptedException {

        // 1. Однопоточный рекурсивный подсчет размера директории
        // 2. Многопоточный рекурсивный (1 поток на 1 директорию)
        // 3. Многопоточный с пулом потоков

        File file = new File("c:\\utils");
//        System.out.println(countSize(file));


        ThreadPoolExecutor executor = new ThreadPoolExecutor(20, 30, 10, TimeUnit.SECONDS, new LinkedBlockingQueue<>());

        executor.execute(() -> {
            long start = System.currentTimeMillis();
            System.out.println(countSize(file));
            System.out.println("Took: " + (System.currentTimeMillis() - start));
        });

//        executor.awaitTermination(100, TimeUnit.SECONDS);
        executor.shutdown();
    }

    public static long countSize(File parent) {
        File[] files = parent.listFiles();
        long size = 0;
        for(File f : files) {
            if (f.isDirectory()) {
                size += countSize(f);
            } else {
                size += f.length();
            }
        }
        return size;
    }
}
