package ru.mai.dep806.threads;

import java.util.*;

/**
 * Created by EUGENEL on 16.04.2015.
 */
public class SyncronizeSample {

    //    private static Map<String, Integer> counter = Collections.synchronizedMap(new HashMap<>());
    private static Map<String, Integer> counter = new HashMap<>();
    private static final Object monitor = new Object();
    private static final List<Object> monitors = new ArrayList<>();

    public static void main(String[] args) throws InterruptedException {

        for (int i = 0; i < 10000; i++) {
            monitors.add(new Object());
        }

        long start = System.currentTimeMillis();
        List<Thread> threads = new ArrayList<>();
        for (int i = 0; i < 100; i++) {
            final int threadNum = i;
            Thread thread = new Thread(() -> incrementCounter(threadNum));
            thread.start();
            threads.add(thread);
        }
        for (Thread t : threads) {
            t.join();
        }
        System.out.println((System.currentTimeMillis() - start));
        System.out.println(new TreeMap<String, Integer>(counter));
        System.out.println(counter.size());
    }

    public synchronized static void incrementCounter(int threadNumber) {
        System.err.println("Start " + threadNumber);
        for (int i = 0; i < 10000; i++) {
//            synchronized (monitor) {
            synchronized (monitors.get(i)) {
                Integer count = null;
                count = counter.get(String.valueOf(i));

                if (count == null) {
                    count = 0;
                }

                counter.put(String.valueOf(i), count + 1);
            }
        }

        System.err.println("End " + threadNumber);
    }

    public void doSmth() {
        synchronized (this) {

        }
    }
}
