package ru.mai.dep806.threads;

import java.util.Random;

/**
 * Created by EUGENEL on 09.04.2015.
 */
public class ThreadSample {

    public static void main(String[] args) throws InterruptedException {

        Thread t1 = new Thread(new MyRunnable());

        Thread t2 = new Thread(new Runnable() {
            @Override
            public void run() {
                doSmth();
            }
        });

        Thread t4 = new Thread(() -> doSmth());

        Thread t3 = new Thread(ThreadSample::doSmth);

        t1.start();
        t2.start();
        t3.start();
        t4.start();

        Thread backgroundThread = new Thread(() -> {
            while(true) {
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    System.out.println("Interrupted");
                    break;
                }
                System.out.println("I'm alive");
            }
        });
        backgroundThread.setDaemon(true);
        backgroundThread.start();

        t1.join();
        t2.join();
        t3.join();
        t4.join();

        System.out.println("Finish");
    }

    public static class MyRunnable implements Runnable {
        @Override
        public void run() {
            doSmth();
        }
    }

    private static void doSmth() {
        for (int i=0; i<1000; i++) {
            System.err.println(i);
            Thread.yield();
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
