package ru.mai.dep806.threads;

import com.sun.org.apache.xpath.internal.SourceTree;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Created by EUGENEL on 23.04.2015.
 */
public class WaitNotifySample {

    public static class Train implements Runnable {
        String name;
        List<Passenger> passengers = Collections.synchronizedList(new ArrayList<>());

        public Train(String name) {
            this.name = name;
        }

        @Override
        public String toString() {
            return "Train{" +
                    "name='" + name + '\'' +
                    '}';
        }

        @Override
        public void run() {
            System.err.println(name + ": Отходит от вокзала в Москве");
            try {
                Thread.sleep(10000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            System.err.println(name + ": Подходит к станции Новогиреево");
            synchronized (this) {
                System.err.println("Before notify");
                this.notifyAll();
                System.err.println("After notify");
            }
            try {
                Thread.sleep(10000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            System.err.println(name + ": Прибывает в Петушки");
            System.err.println("Пассажиры выходят: " + passengers);
        }

        public void takePassenger(Passenger passenger) {
            System.err.println(passenger.name + " сел в поезд " + name);
            this.passengers.add(passenger);
        }
    }

    public static class Passenger implements Runnable {
        String name;
        private Train train;

        public Passenger(String name, Train train) {
            this.name = name;
            this.train = train;
        }

        @Override
        public String toString() {
            return "Passenger{" +
                    "name='" + name + '\'' +
                    '}';
        }

        @Override
        public void run() {
            System.err.println(name + ": Пришел на платформу");
            try {
                synchronized (train) {
                    // ..
                    train.wait();
                    train.takePassenger(this);
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            System.err.println(name + ": Сел в поезд");
        }
    }

    public static void main(String[] args) throws InterruptedException {

        Train train1 = new Train("Москва-Петушки");

        Passenger p1 = new Passenger("Ерофеев", train1);
        Passenger p2 = new Passenger("Лимонов", train1);

        new Thread(p1).start();
        Thread.sleep(1000);
        new Thread(train1).start();
        Thread.sleep(1000);
        new Thread(p2).start();

    }
}
